#|
;;==================================================
;; INTERFACE MAPPING SETUP (simEval)
;;==================================================
(defsim-pred "eval" *CurrentStateMt* 2)
(sim-assert-now `(#$isa ,(sim-pred "eval") #$AsymmetricBinaryPredicate) *VocabularyMt*)
(sim-assert-now `(#$isa ,(sim-pred "eval") #$IntangibleObjectPredicate) *VocabularyMt*)
(sim-assert-now `(#$isa ,(sim-pred "eval") #$FunctionalPredicate) *VocabularyMt*)
(sim-assert-now `(#$comment ,(sim-pred "eval") " (#$simEval (#$TheList .....) ?Result)") *VocabularyMt*)
(sim-assert-now `(#$arity ,(sim-pred "eval") 2) *VocabularyMt*)
(sim-assert-now `(#$arg1Isa ,(sim-pred "eval") #$Thing) *VocabularyMt*)
(sim-assert-now `(#$arg2Isa ,(sim-pred "eval") #$Thing) *VocabularyMt*)
(sim-assert-now `(#$notAssertible ,(sim-pred "eval") ) *VocabularyMt*)
(defparameter *sim-host* "10.10.10.193")
(defparameter *sim-port* 3650)
(define sim-eval (&rest outval) 
 (THROW-UNEVALUATABLE-ON-ERROR 
 (ret (clet (*retval* (*stream* (OPEN-TCP-STREAM *Sim-HOST* *Sim-PORT*))) #$BaseKB)
  (prin1 outval *stream*)
  (terpri *stream*)(force-output *stream*)
  (csetq *retval* (read *stream*)) #$BaseKB)
  (close *stream*) *retval*)))) 
(define sim-eval (&rest outval) 
  (terpri)(princ ";; Sim-EVAL")
  (print outval)(force-output) 
  (ret outval )) #$BaseKB)

(defmacro defsim-query (simname value pred result) 
 (clet ((const (sim-clms (Arg2Isa pred) simname "Sim-" (constant-name type) "-CMLS"))))(clet ((res (sim-eval `(,simname ))))))  
(defsim-query "classname" "light" #$isa #$LightingDevice)
(defsim-query "orientation" ?P #$locatedAt-Point (coerce-pointfn ?P)) #$BaseKB)
(sim-predicate "touches" ?P #$locatedAt-Point (coerce-pointfn ?P)) #$BaseKB)
 (sim-assert-now `(#$structuredKnowledgeSourceName NIL SKSIContentMicrotheory) ,*MappingMt*)
(defparameter *Sim-KS* (find-or-create-constant "Sim-KS")) #$BaseKB)
(defparameter *Sim-PS* (find-or-create-constant "Sim-PS")) #$BaseKB)
(defparameter *Sim-LS* (find-or-create-constant "Sim-LS")) #$BaseKB)
(define sim-clms (type simname) 
 (clet ((clms (sim-cyc (cconcatenate "Sim-" (constant-name type) "-CMLS")))) 
  (sim-assert-now `(#$isa ,clms #$ReifiedMapping ) *MappingMt*)  
  (sim-assert-now `(#$schemaIsa ,clms ,type ) *MappingMt*)  
  (sim-assert-now `(#$logicalFieldMapping ,const #$Sim-LS ) *MappingMt*) 
 (ret clms))) #$BaseKB)
(define sim-codemapping (type simname value) 
 (clet ((clms (sim-clms type simname))) #$BaseKB)
  (sim-assert-now `(#$codeMapping ,clms ,simname ,value ) *MappingMt*)
 (ret clms))) #$BaseKB)
    
(sim-assert-now `(#$isa NIL #$StructuredKnowledgeSource) *MappingMt*)
(sim-assert-now `(#$structuredKnowledgeSourceName NIL "Sim Running") *MappingMt*)
(sim-assert-now `(#$sksSourceDescriptionMt NIL ,*MappingMt* ) *MappingMt*)
(sim-assert-now `(#$isa #$Sim-LS #$LogicalSchema) *MappingMt*)
(sim-assert-now `(#$isa #$Sim-PS #$PhysicalSchema) *MappingMt*)
(sim-assert-now `(#$physicalSchemaSourceMap #$Sim-PS NIL) *MappingMt*)
(sim-assert-now `(#$schemaFieldNameList #$Sim-PS (#$TheList "classname" "id" "inherit" "model" "skin" "owner" "color" "rezclass" "origin" "name" "orientation")) *MappingMT*)
(sim-assert-now `(#$logicalSchemaSourceMap #$Sim-LS NIL) *MappingMt*)
(sim-assert-now `(#$logicalPhysicalSchemaMap #$Sim-LS #$Sim-PS) *MappingMt*)

(define sim-fm (type simname &optional n)
 (clet ((clms (sim-clms type simname))(pf `(#$PhysicalFieldFn #$Sim-PS ,simname))(lf (fif n `(#$LogicalFieldFn #$Sim-LS ,type ,n)))) #$BaseKB)
    (sim-assert-now `(#$schemaIsa ,clms ,type ) *MappingMt*)  
    (sim-assert-now `(#$physicalFields #$Sim-PS ,pf) *MappingMt*)
    (sim-assert-now `(#$fieldName ,pf ,simname) *MappingMt*)
    (sim-assert-now `(#$fieldDataType ,pf #$StringObject) *MappingMt*)  
    (pwhen lf 
     (sim-assert-now `(#$logicalFields #$Sim-LS ,lf) *MappingMt*)
     (sim-assert-now `(#$fieldIsa ,lf ,type) *MappingMt*)    
     (sim-assert-now `(#$logicalPhysicalFieldMap ,lf ,pf )*MappingMt*)) #$BaseKB)
 (ret clms))) #$BaseKB)
  
(sim-fm #$Collection "classname" 1)
(sim-fm #$Collection "inherit")
(sim-fm #$Color "color")

(sim-codemapping #$Collection "light" #$LightingDevice)
(sim-codemapping #$Collection "door" #$Doorway)
(sim-codemapping #$Color "blue" #$BlueColor)
(sim-codemapping #$OrientationVector "0 0 1" #$RightSideUp)
   
 
 PID USER  PR NI VIRT RES SHR S %CPU %MEM TIME+ COMMAND
 7224 root  12 -13 1954m 516m 142m R 99.7 25.5 413:06.24 latest.bin
;;==================================================
;; COLLECTION MAPPING SETUP (AtemporalNecessarilyEssentialCollectionType)
;;==================================================
;;(parse-a-question-completely "Are sodium and chlorine the complete list of elements in the chemical formula of chloride?" #$AllLexicalMicrotheoryPSC )
      
;;;;(load "cynd//opt/lotus/sim/src/daxmoo/worlds/10.kif")

(define sim-print-constant (str)
 (cdolist 
  (ele (GATHER-TERM-ASSERTIONS (find-constant str))) #$BaseKB)
  (format t "~s ~%" (assertion-el-ist-formula ele)) #$BaseKB)
  (terpri))) #$BaseKB)




(defparameter *sim-sksi* ())
(define sim-print-constant (str)
    (cdolist 
       (ele (GATHER-TERM-ASSERTIONS (find-constant str)))
       (cpushnew `(cyc-assert ',(assertion-el-ist-formula ele) #$BaseKB) *sim-sksi* #'equal)))



(find-or-create-constant "SimServerStore-KS")
(find-or-create-constant "SimServerStore-binary_relation-KS")
(find-or-create-constant "SimServerStore-binary_relation-LS")
(find-or-create-constant "SimServerStore-binary_relation-PS")
(find-or-create-constant "SimServerStore-binary_relation-binary_relation_arg0-TheIndex")
(find-or-create-constant "SimServerStore-binary_relation-binary_relation_arg1-TheIndex")
(find-or-create-constant "SimServerStore-binary_relation-binary_relation_arg2-TheIndex")
(find-or-create-constant "SimServerStore-binary_relation-binary_relation_pkey-TheIndex")
(find-or-create-constant "SimServerStore-quaternary_relation-KS")
(find-or-create-constant "SimServerStore-quaternary_relation-LS")
(find-or-create-constant "SimServerStore-quaternary_relation-PS")
(find-or-create-constant "SimServerStore-quaternary_relation-quaternary_relation_arg0-TheIndex")
(find-or-create-constant "SimServerStore-quaternary_relation-quaternary_relation_arg1-TheIndex")
(find-or-create-constant "SimServerStore-quaternary_relation-quaternary_relation_arg2-TheIndex")
(find-or-create-constant "SimServerStore-quaternary_relation-quaternary_relation_arg3-TheIndex")
(find-or-create-constant "SimServerStore-quaternary_relation-quaternary_relation_arg4-TheIndex")
(find-or-create-constant "SimServerStore-quaternary_relation-quaternary_relation_pkey-TheIndex")
(find-or-create-constant "SimServerStore-quintary_relation-KS")
(find-or-create-constant "SimServerStore-quintary_relation-LS")
(find-or-create-constant "SimServerStore-quintary_relation-PS")
(find-or-create-constant "SimServerStore-quintary_relation-quintary_relation_arg0-TheIndex")
(find-or-create-constant "SimServerStore-quintary_relation-quintary_relation_arg1-TheIndex")
(find-or-create-constant "SimServerStore-quintary_relation-quintary_relation_arg2-TheIndex")
(find-or-create-constant "SimServerStore-quintary_relation-quintary_relation_arg3-TheIndex")
(find-or-create-constant "SimServerStore-quintary_relation-quintary_relation_arg4-TheIndex")
(find-or-create-constant "SimServerStore-quintary_relation-quintary_relation_arg5-TheIndex")
(find-or-create-constant "SimServerStore-quintary_relation-quintary_relation_pkey-TheIndex")
(find-or-create-constant "SimServerStore-ternary_relation-KS")
(find-or-create-constant "SimServerStore-ternary_relation-LS")
(find-or-create-constant "SimServerStore-ternary_relation-PS")
(find-or-create-constant "SimServerStore-ternary_relation-ternary_relation_arg0-TheIndex")
(find-or-create-constant "SimServerStore-ternary_relation-ternary_relation_arg1-TheIndex")
(find-or-create-constant "SimServerStore-ternary_relation-ternary_relation_arg2-TheIndex")
(find-or-create-constant "SimServerStore-ternary_relation-ternary_relation_arg3-TheIndex")
(find-or-create-constant "SimServerStore-ternary_relation-ternary_relation_pkey-TheIndex")
(find-or-create-constant "SimServerStore-unary_relation-KS")
(find-or-create-constant "SimServerStore-unary_relation-LS")
(find-or-create-constant "SimServerStore-unary_relation-PS")
(find-or-create-constant "SimServerStore-unary_relation-unary_relation_arg0-TheIndex")
(find-or-create-constant "SimServerStore-unary_relation-unary_relation_arg1-TheIndex")
(find-or-create-constant "SimServerStore-unary_relation-unary_relation_pkey-TheIndex")
(find-or-create-constant "SimServerStoreLogicalSchemaDescriptionMt")
(find-or-create-constant "SimServerStorePhysicalSchemaDescriptionMt")
(find-or-create-constant "SimServerStoreSchemaTranslationMt")
(find-or-create-constant "SimServerStoreSourceDescriptionMt")

(cdolist (list *sim-sksi* )
	  (format t "~s ~%" list))

|#

#|


(define setup-sim-sksi ()
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$comment #$SimServerStore-binary_relation-PS "A physical schema for #$SimServerStore-binary_relation-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$comment #$SimServerStore-quaternary_relation-PS "A physical schema for #$SimServerStore-quaternary_relation-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$comment #$SimServerStore-quintary_relation-PS "A physical schema for #$SimServerStore-quintary_relation-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$comment #$SimServerStore-ternary_relation-PS "A physical schema for #$SimServerStore-ternary_relation-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$comment #$SimServerStore-unary_relation-PS "A physical schema for #$SimServerStore-unary_relation-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$examplePredSentences #$sksModuleTypeDirection (#$ist #$SimServerStoreSourceDescriptionMt (#$sksModuleTypeDirection #$SimServerStore-KS #$SKSISingleLiteralRemovalModule #$Forward-AssertionDirection)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreLogicalSchemaDescriptionMt #$BaseKB)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreLogicalSchemaDescriptionMt #$SKSIMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStorePhysicalSchemaDescriptionMt #$BaseKB)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStorePhysicalSchemaDescriptionMt #$SKSIMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreSchemaTranslationMt #$BaseKB)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreSchemaTranslationMt #$SimServerStoreLogicalSchemaDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreSchemaTranslationMt #$SimServerStorePhysicalSchemaDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreSchemaTranslationMt #$SKSIMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreSourceDescriptionMt #$BaseKB)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreSourceDescriptionMt #$CycorpLANModel-CycSecureDataMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreSourceDescriptionMt #$SimServerStoreSchemaTranslationMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$genlMt #$SimServerStoreSourceDescriptionMt #$SKSIMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-KS #$StructuredKnowledgeSource)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-binary_relation-KS #$StructuredKnowledgeSource)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-binary_relation-LS #$LogicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-binary_relation-PS #$PhysicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-binary_relation-binary_relation_arg0-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-binary_relation-binary_relation_arg1-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-binary_relation-binary_relation_arg2-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-binary_relation-binary_relation_pkey-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quaternary_relation-KS #$StructuredKnowledgeSource)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quaternary_relation-LS #$LogicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quaternary_relation-PS #$PhysicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quaternary_relation-quaternary_relation_arg0-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quaternary_relation-quaternary_relation_arg1-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quaternary_relation-quaternary_relation_arg2-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quaternary_relation-quaternary_relation_arg3-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quaternary_relation-quaternary_relation_arg4-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quaternary_relation-quaternary_relation_pkey-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-KS #$StructuredKnowledgeSource)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-LS #$LogicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-PS #$PhysicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-quintary_relation_arg0-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-quintary_relation_arg1-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-quintary_relation_arg2-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-quintary_relation_arg3-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-quintary_relation_arg4-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-quintary_relation_arg5-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-quintary_relation-quintary_relation_pkey-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-ternary_relation-KS #$StructuredKnowledgeSource)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-ternary_relation-LS #$LogicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-ternary_relation-PS #$PhysicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-ternary_relation-ternary_relation_arg0-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-ternary_relation-ternary_relation_arg1-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-ternary_relation-ternary_relation_arg2-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-ternary_relation-ternary_relation_arg3-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-ternary_relation-ternary_relation_pkey-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-unary_relation-KS #$StructuredKnowledgeSource)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-unary_relation-LS #$LogicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-unary_relation-PS #$PhysicalSchema)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-unary_relation-unary_relation_arg0-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-unary_relation-unary_relation_arg1-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStore-unary_relation-unary_relation_pkey-TheIndex #$IndexDataStructure)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStoreLogicalSchemaDescriptionMt #$SKSILogicalSchemaDescriptionMicrotheory)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStorePhysicalSchemaDescriptionMt #$SKSIPhysicalSchemaDescriptionMicrotheory)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStoreSchemaTranslationMt #$SKSISchemaTranslationMicrotheory)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStoreSourceDescriptionMt #$Microtheory)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$isa #$SimServerStoreSourceDescriptionMt #$SKSISourceDescriptionMicrotheory)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$sksLogicalSchemaDescriptionMt #$SimServerStore-KS #$SimServerStoreLogicalSchemaDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$sksPhysicalSchemaDescriptionMt #$SimServerStore-KS #$SimServerStorePhysicalSchemaDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$sksSchemaTranslationMt #$SimServerStore-KS #$SimServerStoreSchemaTranslationMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$UniversalVocabularyMt (#$sksSourceDescriptionMt #$SimServerStore-KS #$SimServerStoreSourceDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$contentMt #$SimServerStore-KS (#$ContentMtFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$contentMt #$SimServerStore-binary_relation-KS (#$ContentMtFn #$SimServerStore-binary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$contentMt #$SimServerStore-quaternary_relation-KS (#$ContentMtFn #$SimServerStore-quaternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$contentMt #$SimServerStore-quintary_relation-KS (#$ContentMtFn #$SimServerStore-quintary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$contentMt #$SimServerStore-ternary_relation-KS (#$ContentMtFn #$SimServerStore-ternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$contentMt #$SimServerStore-unary_relation-KS (#$ContentMtFn #$SimServerStore-unary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$definingMt #$SimServerStore-KS #$SimServerStoreSourceDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$definingMt #$SimServerStore-binary_relation-KS #$SimServerStoreSourceDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$definingMt #$SimServerStore-quaternary_relation-KS #$SimServerStoreSourceDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$definingMt #$SimServerStore-quintary_relation-KS #$SimServerStoreSourceDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$definingMt #$SimServerStore-ternary_relation-KS #$SimServerStoreSourceDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$definingMt #$SimServerStore-unary_relation-KS #$SimServerStoreSourceDescriptionMt)) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryFolderForSKSFn #$SimServerStore-KS) (#$BuilderQueryFolderForSKSFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryFolderForSKSFn #$SimServerStore-binary_relation-KS) (#$BuilderQueryFolderForSKSFn #$SimServerStore-binary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryFolderForSKSFn #$SimServerStore-quaternary_relation-KS) (#$BuilderQueryFolderForSKSFn #$SimServerStore-quaternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryFolderForSKSFn #$SimServerStore-quintary_relation-KS) (#$BuilderQueryFolderForSKSFn #$SimServerStore-quintary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryFolderForSKSFn #$SimServerStore-ternary_relation-KS) (#$BuilderQueryFolderForSKSFn #$SimServerStore-ternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryFolderForSKSFn #$SimServerStore-unary_relation-KS) (#$BuilderQueryFolderForSKSFn #$SimServerStore-unary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$BinaryPredicate) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$BinaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$CycLSentence) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$Thing) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$CycLSentence) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$QuaternaryPredicate) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$QuaternaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$Thing) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$CycLSentence) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$QuintaryPredicate) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$QuintaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$Thing) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$CycLSentence) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$TernaryPredicate) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$TernaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$Thing) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$CycLSentence) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$Thing) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$UnaryPredicate) (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$UnaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$BinaryPredicate) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$BinaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$CycLSentence) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$Thing) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$CycLSentence) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$QuaternaryPredicate) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$QuaternaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$Thing) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$CycLSentence) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$QuintaryPredicate) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$QuintaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$Thing) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$CycLSentence) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$TernaryPredicate) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$TernaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$Thing) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$CycLSentence) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$Thing) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$UnaryPredicate) (#$BuilderQueryTemplateForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$UnaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ContentMtFn #$SimServerStore-KS) (#$ContentMtFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ContentMtFn #$SimServerStore-binary_relation-KS) (#$ContentMtFn #$SimServerStore-binary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ContentMtFn #$SimServerStore-quaternary_relation-KS) (#$ContentMtFn #$SimServerStore-quaternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ContentMtFn #$SimServerStore-quintary_relation-KS) (#$ContentMtFn #$SimServerStore-quintary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ContentMtFn #$SimServerStore-ternary_relation-KS) (#$ContentMtFn #$SimServerStore-ternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ContentMtFn #$SimServerStore-unary_relation-KS) (#$ContentMtFn #$SimServerStore-unary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ContentMtHeadFn #$SimServerStore-KS) (#$ContentMtHeadFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ContentMtSpindleFn #$SimServerStore-KS) (#$ContentMtSpindleFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ExampleQueryFolderForSKSFn #$SimServerStore-KS) (#$ExampleQueryFolderForSKSFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1) (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 1) (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 2) (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1) (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 1) (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 2) (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 3) (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 4) (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 4))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1) (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 1) (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 2) (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 3) (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 4) (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 4))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 5) (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 5))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1) (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 1) (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 2) (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 3) (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$Thing 1) (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1) (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$QueryFolderForSKSFn #$SimServerStore-KS) (#$QueryFolderForSKSFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 1) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 2) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 1) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 2) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 3) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 4) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 4))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 1) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 2) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 3) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 4) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 4))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 5) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 5))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 1) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 2) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 3) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$Thing 1) (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg2") (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg2") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg3") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg4") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg2") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg3") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg4") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg5") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg2") (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg3") (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$BaseKB (#$termOfUnit (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1) "arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) "arg0 arg1 arg2")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 1) "arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 2) "arg2")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) "arg0 arg1 arg2 arg3 arg4")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1) "arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 1) "arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 2) "arg2")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 3) "arg3")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 4) "arg4")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) "arg0 arg1 arg2 arg3 arg4 arg5")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1) "arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 1) "arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 2) "arg2")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 3) "arg3")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 4) "arg4")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 5) "arg5")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) "arg0 arg1 arg2 arg3")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1) "arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 1) "arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 2) "arg2")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 3) "arg3")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) "arg0 arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$Thing 1) "arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$fieldName-SKS (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1) "arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$logicalSchemaFieldTypeList #$SimServerStore-binary_relation-LS (#$TheList #$CycLSentence #$BinaryPredicate #$Thing #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$logicalSchemaFieldTypeList #$SimServerStore-quaternary_relation-LS (#$TheList #$CycLSentence #$QuaternaryPredicate #$Thing #$Thing #$Thing #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$logicalSchemaFieldTypeList #$SimServerStore-quintary_relation-LS (#$TheList #$CycLSentence #$QuintaryPredicate #$Thing #$Thing #$Thing #$Thing #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$logicalSchemaFieldTypeList #$SimServerStore-ternary_relation-LS (#$TheList #$CycLSentence #$TernaryPredicate #$Thing #$Thing #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$logicalSchemaFieldTypeList #$SimServerStore-unary_relation-LS (#$TheList #$CycLSentence #$UnaryPredicate #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$meaningSentenceOfSchema #$SimServerStore-binary_relation-LS ((#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 1) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 2)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$meaningSentenceOfSchema #$SimServerStore-quaternary_relation-LS ((#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 1) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 2) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 3) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 4)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$meaningSentenceOfSchema #$SimServerStore-quintary_relation-LS ((#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 1) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 2) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 3) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 4) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 5)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$meaningSentenceOfSchema #$SimServerStore-ternary_relation-LS ((#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 1) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 2) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 3)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$meaningSentenceOfSchema #$SimServerStore-unary_relation-LS ((#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1) (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$Thing 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 4))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 4))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 5))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 4))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 4))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 5))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 2))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 3))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$CycLSentence 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$Thing 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreLogicalSchemaDescriptionMt (#$retainTerm (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$enumerableSchema #$SimServerStore-binary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$enumerableSchema #$SimServerStore-quaternary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$enumerableSchema #$SimServerStore-quintary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$enumerableSchema #$SimServerStore-ternary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$enumerableSchema #$SimServerStore-unary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-binary_relation-binary_relation_arg0-TheIndex "binary_relation_arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-binary_relation-binary_relation_arg1-TheIndex "binary_relation_arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-binary_relation-binary_relation_arg2-TheIndex "binary_relation_arg2")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-binary_relation-binary_relation_pkey-TheIndex "binary_relation_pkey")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quaternary_relation-quaternary_relation_arg0-TheIndex "quaternary_relation_arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quaternary_relation-quaternary_relation_arg1-TheIndex "quaternary_relation_arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quaternary_relation-quaternary_relation_arg2-TheIndex "quaternary_relation_arg2")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quaternary_relation-quaternary_relation_arg3-TheIndex "quaternary_relation_arg3")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quaternary_relation-quaternary_relation_arg4-TheIndex "quaternary_relation_arg4")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quaternary_relation-quaternary_relation_pkey-TheIndex "quaternary_relation_pkey")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quintary_relation-quintary_relation_arg0-TheIndex "quintary_relation_arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quintary_relation-quintary_relation_arg1-TheIndex "quintary_relation_arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quintary_relation-quintary_relation_arg2-TheIndex "quintary_relation_arg2")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quintary_relation-quintary_relation_arg3-TheIndex "quintary_relation_arg3")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quintary_relation-quintary_relation_arg4-TheIndex "quintary_relation_arg4")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quintary_relation-quintary_relation_arg5-TheIndex "quintary_relation_arg5")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-quintary_relation-quintary_relation_pkey-TheIndex "quintary_relation_pkey")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-ternary_relation-ternary_relation_arg0-TheIndex "ternary_relation_arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-ternary_relation-ternary_relation_arg1-TheIndex "ternary_relation_arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-ternary_relation-ternary_relation_arg2-TheIndex "ternary_relation_arg2")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-ternary_relation-ternary_relation_arg3-TheIndex "ternary_relation_arg3")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-ternary_relation-ternary_relation_pkey-TheIndex "ternary_relation_pkey")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-unary_relation-unary_relation_arg0-TheIndex "unary_relation_arg0")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-unary_relation-unary_relation_arg1-TheIndex "unary_relation_arg1")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexName #$SimServerStore-unary_relation-unary_relation_pkey-TheIndex "unary_relation_pkey")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexedFields #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2") (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4") (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5") (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3") (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$indexicalForPhysicalField (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1") (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFieldList #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFieldList #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFieldList #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFieldList #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFieldList #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-binary_relation-PS (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-binary_relation-PS (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-binary_relation-PS (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-ternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-ternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-ternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-ternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-unary_relation-PS (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$nonNullFields #$SimServerStore-unary_relation-PS (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-binary_relation-PS (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-binary_relation-PS (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-binary_relation-PS (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quaternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-quintary_relation-PS (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-ternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-ternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-ternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-ternary_relation-PS (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-unary_relation-PS (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalFields #$SimServerStore-unary_relation-PS (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalSchemaSourceMap #$SimServerStore-binary_relation-PS #$SimServerStore-binary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalSchemaSourceMap #$SimServerStore-quaternary_relation-PS #$SimServerStore-quaternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalSchemaSourceMap #$SimServerStore-quintary_relation-PS #$SimServerStore-quintary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalSchemaSourceMap #$SimServerStore-ternary_relation-PS #$SimServerStore-ternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$physicalSchemaSourceMap #$SimServerStore-unary_relation-PS #$SimServerStore-unary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$primaryKey #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$primaryKey #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$primaryKey #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$primaryKey #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$primaryKey #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$resultSetCardinality #$SimServerStore-binary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")) (#$TheSet (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")) 1)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$resultSetCardinality #$SimServerStore-quaternary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")) (#$TheSet (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")) 1)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$resultSetCardinality #$SimServerStore-quintary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")) (#$TheSet (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")) 1)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$resultSetCardinality #$SimServerStore-ternary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")) (#$TheSet (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")) 1)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$resultSetCardinality #$SimServerStore-unary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")) (#$TheSet (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")) 1)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$retainTerm (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldList #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldList #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldList #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldList #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldList #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldNameList #$SimServerStore-binary_relation-PS (#$TheList "arg0" "arg1" "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldNameList #$SimServerStore-quaternary_relation-PS (#$TheList "arg0" "arg1" "arg2" "arg3" "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldNameList #$SimServerStore-quintary_relation-PS (#$TheList "arg0" "arg1" "arg2" "arg3" "arg4" "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldNameList #$SimServerStore-ternary_relation-PS (#$TheList "arg0" "arg1" "arg2" "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldNameList #$SimServerStore-unary_relation-PS (#$TheList "arg0" "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")) "binary_relation_pkey" #$SimServerStore-binary_relation-binary_relation_pkey-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0")) "binary_relation_arg0" #$SimServerStore-binary_relation-binary_relation_arg0-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1")) "binary_relation_arg1" #$SimServerStore-binary_relation-binary_relation_arg1-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")) "binary_relation_arg2" #$SimServerStore-binary_relation-binary_relation_arg2-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")) "quaternary_relation_pkey" #$SimServerStore-quaternary_relation-quaternary_relation_pkey-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0")) "quaternary_relation_arg0" #$SimServerStore-quaternary_relation-quaternary_relation_arg0-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1")) "quaternary_relation_arg1" #$SimServerStore-quaternary_relation-quaternary_relation_arg1-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2")) "quaternary_relation_arg2" #$SimServerStore-quaternary_relation-quaternary_relation_arg2-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3")) "quaternary_relation_arg3" #$SimServerStore-quaternary_relation-quaternary_relation_arg3-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")) "quaternary_relation_arg4" #$SimServerStore-quaternary_relation-quaternary_relation_arg4-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")) "quintary_relation_pkey" #$SimServerStore-quintary_relation-quintary_relation_pkey-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0")) "quintary_relation_arg0" #$SimServerStore-quintary_relation-quintary_relation_arg0-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1")) "quintary_relation_arg1" #$SimServerStore-quintary_relation-quintary_relation_arg1-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2")) "quintary_relation_arg2" #$SimServerStore-quintary_relation-quintary_relation_arg2-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3")) "quintary_relation_arg3" #$SimServerStore-quintary_relation-quintary_relation_arg3-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4")) "quintary_relation_arg4" #$SimServerStore-quintary_relation-quintary_relation_arg4-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")) "quintary_relation_arg5" #$SimServerStore-quintary_relation-quintary_relation_arg5-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")) "ternary_relation_pkey" #$SimServerStore-ternary_relation-ternary_relation_pkey-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0")) "ternary_relation_arg0" #$SimServerStore-ternary_relation-ternary_relation_arg0-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1")) "ternary_relation_arg1" #$SimServerStore-ternary_relation-ternary_relation_arg1-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2")) "ternary_relation_arg2" #$SimServerStore-ternary_relation-ternary_relation_arg2-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")) "ternary_relation_arg3" #$SimServerStore-ternary_relation-ternary_relation_arg3-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")) "unary_relation_pkey" #$SimServerStore-unary_relation-unary_relation_pkey-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0")) "unary_relation_arg0" #$SimServerStore-unary_relation-unary_relation_arg0-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaFieldsIndex #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")) "unary_relation_arg1" #$SimServerStore-unary_relation-unary_relation_arg1-TheIndex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaKeys #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaKeys #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaKeys #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaKeys #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$schemaKeys #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-binary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quaternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-quintary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-ternary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStorePhysicalSchemaDescriptionMt (#$uniqueFieldList #$SimServerStore-unary_relation-PS (#$TheList (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-binary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1) #$SimServerStore-binary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-binary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) #$SimServerStore-binary_relation-PS (#$MakeFormulaFn ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg0")) (#$TheList ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg1")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg2")))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-binary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 1) #$SimServerStore-binary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-binary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 2) #$SimServerStore-binary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quaternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) #$SimServerStore-quaternary_relation-PS (#$MakeFormulaFn ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg0")) (#$TheList ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg1")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg2")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg3")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg4")))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quaternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1) #$SimServerStore-quaternary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quaternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 1) #$SimServerStore-quaternary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quaternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 2) #$SimServerStore-quaternary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quaternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 3) #$SimServerStore-quaternary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quaternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 4) #$SimServerStore-quaternary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quintary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) #$SimServerStore-quintary_relation-PS (#$MakeFormulaFn ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg0")) (#$TheList ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg1")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg2")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg3")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg4")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg5")))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quintary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1) #$SimServerStore-quintary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quintary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 1) #$SimServerStore-quintary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quintary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 2) #$SimServerStore-quintary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quintary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 3) #$SimServerStore-quintary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quintary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 4) #$SimServerStore-quintary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg4")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-quintary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 5) #$SimServerStore-quintary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg5")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-ternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) #$SimServerStore-ternary_relation-PS (#$MakeFormulaFn ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg0")) (#$TheList ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg1")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg2")) ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg3")))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-ternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1) #$SimServerStore-ternary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-ternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 1) #$SimServerStore-ternary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-ternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 2) #$SimServerStore-ternary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg2")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-ternary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 3) #$SimServerStore-ternary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg3")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-unary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) #$SimServerStore-unary_relation-PS (#$MakeFormulaFn ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg0")) (#$TheList ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg1")))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-unary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$Thing 1) #$SimServerStore-unary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg1")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldDecoding #$SimServerStore-unary_relation-LS (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1) #$SimServerStore-unary_relation-PS ((#$FunctionToArg 1 #$termExternalIDString) (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg0")))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-binary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg0") #$SimServerStore-binary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-binary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg0") #$SimServerStore-binary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 0 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-binary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg1") #$SimServerStore-binary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-binary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg1") #$SimServerStore-binary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 1 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-binary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg2") #$SimServerStore-binary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$Thing 2)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-binary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-binary_relation-PS "arg2") #$SimServerStore-binary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 2 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-binary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg0") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg0") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 0 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg1") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg1") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 1 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg2") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 2)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg2") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 2 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg3") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 3)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg3") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 3 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg4") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$Thing 4)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quaternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quaternary_relation-PS "arg4") #$SimServerStore-quaternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 4 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg0") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg0") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 0 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg1") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg1") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 1 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg2") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 2)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg2") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 2 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg3") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 3)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg3") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 3 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg4") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 4)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg4") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 4 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg5") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$Thing 5)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-quintary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-quintary_relation-PS "arg5") #$SimServerStore-quintary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 5 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-ternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg0") #$SimServerStore-ternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-ternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg0") #$SimServerStore-ternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 0 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-ternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg1") #$SimServerStore-ternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-ternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg1") #$SimServerStore-ternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 1 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-ternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg2") #$SimServerStore-ternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 2)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-ternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg2") #$SimServerStore-ternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 2 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-ternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg3") #$SimServerStore-ternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$Thing 3)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-ternary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-ternary_relation-PS "arg3") #$SimServerStore-ternary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 3 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-unary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg0") #$SimServerStore-unary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-unary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg0") #$SimServerStore-unary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 0 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-unary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg1") #$SimServerStore-unary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$Thing 1)))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$fieldEncoding #$SimServerStore-unary_relation-PS (#$ThePhysicalFieldValueFn #$SimServerStore-unary_relation-PS "arg1") #$SimServerStore-unary_relation-LS ((#$FunctionToArg 2 #$termExternalIDString) ((#$FunctionToArg 1 (#$Kappa (?TERM ?FORMULA) (#$argN ?TERM 1 ?FORMULA))) (#$TheLogicalFieldValueFn #$SimServerStore-unary_relation-LS #$CycLSentence 1))))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-binary_relation-KS #$BinaryPredicate)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-binary_relation-KS #$CycLSentence)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-binary_relation-KS #$Thing)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-quaternary_relation-KS #$CycLSentence)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-quaternary_relation-KS #$QuaternaryPredicate)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-quaternary_relation-KS #$Thing)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-quintary_relation-KS #$CycLSentence)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-quintary_relation-KS #$QuintaryPredicate)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-quintary_relation-KS #$Thing)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-ternary_relation-KS #$CycLSentence)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-ternary_relation-KS #$TernaryPredicate)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-ternary_relation-KS #$Thing)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-unary_relation-KS #$CycLSentence)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-unary_relation-KS #$Thing)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalFieldTypeForSource #$SimServerStore-unary_relation-KS #$UnaryPredicate)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 3) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 4) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 3) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 4) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 5) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 3) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 3) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 4) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 3) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 4) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 5) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 3) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-DecodeClosed (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$BinaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-binary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$QuaternaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 3) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quaternary_relation-LS #$Thing 4) (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$QuintaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 3) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 4) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-quintary_relation-LS #$Thing 5) (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$TernaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 2) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-ternary_relation-LS #$Thing 3) (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$CycLSentence 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$Thing 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalFieldMap-EncodeClosed (#$LogicalFieldFn #$SimServerStore-unary_relation-LS #$UnaryPredicate 1) (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0"))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalSchemaMap #$SimServerStore-binary_relation-LS #$SimServerStore-binary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalSchemaMap #$SimServerStore-quaternary_relation-LS #$SimServerStore-quaternary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalSchemaMap #$SimServerStore-quintary_relation-LS #$SimServerStore-quintary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalSchemaMap #$SimServerStore-ternary_relation-LS #$SimServerStore-ternary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalPhysicalSchemaMap #$SimServerStore-unary_relation-LS #$SimServerStore-unary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalSchemaSourceMap #$SimServerStore-binary_relation-LS #$SimServerStore-binary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalSchemaSourceMap #$SimServerStore-quaternary_relation-LS #$SimServerStore-quaternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalSchemaSourceMap #$SimServerStore-quintary_relation-LS #$SimServerStore-quintary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalSchemaSourceMap #$SimServerStore-ternary_relation-LS #$SimServerStore-ternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$logicalSchemaSourceMap #$SimServerStore-unary_relation-LS #$SimServerStore-unary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$BinaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-binary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$QuaternaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quaternary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$QuintaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-quintary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$TernaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-ternary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$CycLSentence))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$Thing))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSchemaTranslationMt (#$retainTerm (#$BuilderQueryForLogicalFieldTypeOfSKSFn #$SimServerStore-unary_relation-KS #$UnaryPredicate))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$comment #$SimServerStore-binary_relation-KS "The \"binary_relation\" table in #$SimServerStore-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$comment #$SimServerStore-quaternary_relation-KS "The \"quaternary_relation\" table in #$SimServerStore-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$comment #$SimServerStore-quintary_relation-KS "The \"quintary_relation\" table in #$SimServerStore-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$comment #$SimServerStore-ternary_relation-KS "The \"ternary_relation\" table in #$SimServerStore-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$comment #$SimServerStore-unary_relation-KS "The \"unary_relation\" table in #$SimServerStore-KS.")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$contentMtHead #$SimServerStore-KS (#$ContentMtHeadFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$contentMtSpindle #$SimServerStore-KS (#$ContentMtSpindleFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$isa #$SimServerStore-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$isa #$SimServerStore-KS #$StructuredKnowledgeSource-Complex)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$isa #$SimServerStore-binary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$isa #$SimServerStore-quaternary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$isa #$SimServerStore-quintary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$isa #$SimServerStore-ternary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$isa #$SimServerStore-unary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$isa (#$ContentMtHeadFn #$SimServerStore-KS) #$SKSIContentMicrotheory)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$isa (#$ContentMtSpindleFn #$SimServerStore-KS) #$SKSIContentMicrotheorySpindle)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$mtSpindle (#$ContentMtSpindleFn #$SimServerStore-KS) (#$ContentMtHeadFn #$SimServerStore-KS) (#$ContentMtFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$mtSpindleCollector (#$ContentMtSpindleFn #$SimServerStore-KS) (#$ContentMtFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$mtSpindleHead (#$ContentMtSpindleFn #$SimServerStore-KS) (#$ContentMtHeadFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$mtSpindleMember (#$ContentMtSpindleFn #$SimServerStore-KS) (#$ContentMtFn #$SimServerStore-binary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$mtSpindleMember (#$ContentMtSpindleFn #$SimServerStore-KS) (#$ContentMtFn #$SimServerStore-quaternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$mtSpindleMember (#$ContentMtSpindleFn #$SimServerStore-KS) (#$ContentMtFn #$SimServerStore-quintary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$mtSpindleMember (#$ContentMtSpindleFn #$SimServerStore-KS) (#$ContentMtFn #$SimServerStore-ternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$mtSpindleMember (#$ContentMtSpindleFn #$SimServerStore-KS) (#$ContentMtFn #$SimServerStore-unary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$passwordForSKS #$SimServerStore-KS "")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$resultSetCardinality #$SimServerStore-binary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-binary_relation-PS "arg2")) #$TheEmptySet 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$resultSetCardinality #$SimServerStore-quaternary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quaternary_relation-PS "arg4")) #$TheEmptySet 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$resultSetCardinality #$SimServerStore-quintary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg3") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg4") (#$PhysicalFieldFn #$SimServerStore-quintary_relation-PS "arg5")) #$TheEmptySet 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$resultSetCardinality #$SimServerStore-ternary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg1") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg2") (#$PhysicalFieldFn #$SimServerStore-ternary_relation-PS "arg3")) #$TheEmptySet 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$resultSetCardinality #$SimServerStore-unary_relation-PS (#$TheSet (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg0") (#$PhysicalFieldFn #$SimServerStore-unary_relation-PS "arg1")) #$TheEmptySet 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$BuilderQueryFolderForSKSFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$ContentMtFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$ContentMtFn #$SimServerStore-binary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$ContentMtFn #$SimServerStore-quaternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$ContentMtFn #$SimServerStore-quintary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$ContentMtFn #$SimServerStore-ternary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$ContentMtFn #$SimServerStore-unary_relation-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$ContentMtHeadFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$ContentMtSpindleFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$ExampleQueryFolderForSKSFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$retainTerm (#$QueryFolderForSKSFn #$SimServerStore-KS))) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$rowCount-SKS #$SimServerStore-binary_relation-KS 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$rowCount-SKS #$SimServerStore-quaternary_relation-KS 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$rowCount-SKS #$SimServerStore-quintary_relation-KS 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$rowCount-SKS #$SimServerStore-ternary_relation-KS 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$rowCount-SKS #$SimServerStore-unary_relation-KS 0)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-binary_relation-LS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-binary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-quaternary_relation-LS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-quaternary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-quintary_relation-LS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-quintary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-ternary_relation-LS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-ternary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-unary_relation-LS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$schemaRepresentationComplete #$SimServerStore-unary_relation-PS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$serverOfSKS #$SimServerStore-KS "lotus")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksIsa #$SimServerStore-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksIsa #$SimServerStore-binary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksIsa #$SimServerStore-quaternary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksIsa #$SimServerStore-quintary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksIsa #$SimServerStore-ternary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksIsa #$SimServerStore-unary_relation-KS #$Database-Physical)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksModifiable #$SimServerStore-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksModifiable #$SimServerStore-binary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksModifiable #$SimServerStore-quaternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksModifiable #$SimServerStore-quintary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksModifiable #$SimServerStore-ternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksModifiable #$SimServerStore-unary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksRepresentationComplete #$SimServerStore-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksRepresentationComplete #$SimServerStore-binary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksRepresentationComplete #$SimServerStore-quaternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksRepresentationComplete #$SimServerStore-quintary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksRepresentationComplete #$SimServerStore-ternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksRepresentationComplete #$SimServerStore-unary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sqlProgramForSKS #$SimServerStore-KS #$PostgreSQL)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$structuredKnowledgeSourceName #$SimServerStore-KS "simple_backing_store")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$structuredKnowledgeSourceName #$SimServerStore-binary_relation-KS "binary_relation")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$structuredKnowledgeSourceName #$SimServerStore-quaternary_relation-KS "quaternary_relation")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$structuredKnowledgeSourceName #$SimServerStore-quintary_relation-KS "quintary_relation")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$structuredKnowledgeSourceName #$SimServerStore-ternary_relation-KS "ternary_relation")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$structuredKnowledgeSourceName #$SimServerStore-unary_relation-KS "unary_relation")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$subKS-Direct #$SimServerStore-KS #$SimServerStore-binary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$subKS-Direct #$SimServerStore-KS #$SimServerStore-quaternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$subKS-Direct #$SimServerStore-KS #$SimServerStore-quintary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$subKS-Direct #$SimServerStore-KS #$SimServerStore-ternary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$subKS-Direct #$SimServerStore-KS #$SimServerStore-unary_relation-KS)) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$subProtocolForSKS #$SimServerStore-KS "postgresql")) #$BaseKB)
(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$userNameForSKS #$SimServerStore-KS "sksi")) #$BaseKB)
)

;;(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksProxyHost #$SimServerStore-KS "standard.cyc.com")) #$BaseKB)
;;(CYC-ASSERT '(#$ist #$SimServerStoreSourceDescriptionMt (#$sksProxyPort #$SimServerStore-KS 9999)) #$BaseKB)

;;(cdolist (list *sim-sksi* )(format t "~s ~%" list))

(setup-sim-sksi)
(setup-sim-sksi)

|#